i = imread('grayimage.gif')   % reads the image into a variable
h = imhist(i)         
s = zeros(256,1)
s(1)= h(1)/(128*128)          % computes the CDF
for k = 2:256
    s(k)= s(k-1)+h(k)/(128*128);
end

i2 = i


for x=1:128*128              % puts back the new pixel values into a 
        z=i(x)               % matrix 
        if(z==0)
            z=1;
        end
        i2(x) = round(255*s(z));  
 
end


figure, imshow(i)                 % displays the old image
figure, imhist(i)                 % displays the old histogram
figure, imhist(i2)                % displays the new histogram
figure, imshow(i2,gray(256))      % displays the new picture







